{% extends 'id/id_base.html' %}
{% load static %}


{% block content %}
    <section>
        <div class="spacer no-spacer">
            <div class="shadow p-30">
                <div class="h3 text-center c-blue mb-5">
                    Encounter Report
                </div>
                <form action="{% url 'backend:report' %}" method="post" enctype="multipart/form-data">
                    <div class="contact-information mb-4">
                        <div class="h4 c-blue mb-3">
                            Informasi Diri
                        </div>
                        <div class="row g-3">
                            <div class="col-md-6">
                                <label for="first_name" class="form-label">
                                    Nama Depan <span class="c-red">*</span>
                                </label>
                                <input type="text" class="form-control" value="{{ request.user.first_name }}" readonly>
                            </div>
                            <div class="col-md-6">
                                <label for="last_name" class="form-label">
                                    Nama Belakang <span class="c-red">*</span>
                                </label>
                                <input type="text" class="form-control" value="{{ request.user.last_name }}" readonly>
                            </div>
                            <div class="col-md-12">
                                <label for="email" class="form-label">
                                    Email <span class="c-red">*</span>
                                </label>
                                <input type="email" class="form-control" value="{{ request.user.email }}" readonly>
                            </div>
                            <div class="col-md-6">
                                <label for="phone" class="form-label">
                                    No Telepon <span class="c-red">*</span>
                                </label>
                                <input type="tel" class="form-control" value="{{ request.user.phone }}" readonly>
                            </div>
                            <div class="col-md-6">
                                <label for="age" class="form-label">
                                    Tanggal Lahir <span class="c-red">*</span>
                                </label>

                                <input type="date" class="form-control" value="{{ request.user.birthday|date:'Y-m-d' }}" readonly>
                            </div>
                            <div class="col-md-12">
                                <label for="job" class="form-label">
                                    Pekerjaan <span class="c-red">*</span>
                                </label>
                                <input type="text" class="form-control" value="{{ request.user.job }}" readonly>
                            </div>
                            <div class="col-md-12">
                                <label for="type" class="form-label">
                                    Jenis Data <span class="c-red">*</span>
                                </label>
                                <div class="form-check mt-2">
                                    <input class="form-check-input" type="checkbox" id="sighting">
                                    <label class="form-check-label" for="sighting">
                                        Sighting <span class="c-blue">(Pertemuan dengan Elasmobranchii hidup)</span>
                                    </label>
                                </div>
                                <div class="form-check mt-2">
                                    <input class="form-check-input" type="checkbox" id="landing">
                                    <label class="form-check-label" for="landing">
                                        Landing <span class="c-blue">(Pertemuan dengan Elasmobranchii yang sudah ditangkap)</span>
                                    </label>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div id="sighting-form" class="mb-3" >
                        <div class="h4 c-blue mb-3">
                            Sighting Data
                        </div>
                        <div class="accordion" id="accordion-sighting"></div>
                        <div class="text-center mt-3">
                            <div class="btn btn-primary" id="add-sighting">
                                <i class="bi bi-plus"></i>
                            </div>
                        </div>
                    </div>
                    <div id="landing-form">
                        <div class="h4 c-blue mb-3">
                            Landing Data
                        </div>
                        <div class="accordion" id="accordion-landing"></div>
                        <div class="text-center mt-3">
                            <div class="btn btn-primary" id="add-landing">
                                <i class="bi bi-plus"></i>
                            </div>
                        </div>
                    </div>
                    <div class="text-center my-5">
                        <button type="submit" class="btn btn-success">
                            <i class="bi bi-check"></i> Submit
                        </button>
                    </div>
                </form>
            </div>
        </div>
    </section>
{% endblock content %}

{% block js %}
    <script>
        $(document).ready(function () {
            const SIGHTING_DATA = "SIGHTING";
            const LANDING_DATA = "LANDING";

            function toggleShow(el, value) {
                if (value) {
                    $(el).show();
                } else {
                    $(el).hide();
                }
            }

            let sighting = "#sighting";
            let sightingForm = "#sighting-form";

            toggleShow(sightingForm, false);
            $(sighting).on('change', function () {
                toggleShow(sightingForm, this.checked);
            });

            let landing = "#landing";
            let landingForm = "#landing-form";

            toggleShow(landingForm, false);
            $(landing).on('change', function () {
                toggleShow(landingForm, this.checked);
            });

            const accordionSighting = "#accordion-sighting";
            const addSighting = "#add-sighting";

            let commonNames = [];
            let scientificNames = [];

            function fetchObservationName() {
                $.ajax({
                    url: '/api/observation/names',
                    type: 'get',
                    dataType: 'json',
                    success: function (data) {
                        if (!!data) {
                            commonNames = data['common_names'];
                            scientificNames = data['scientific_names'];
                        }
                    }
                });
            }

            fetchObservationName();

            let sightingUID = 0;
            $(addSighting).on('click', function() {
                let params = {
                    uid: `S${++sightingUID}`,
                    type: SIGHTING_DATA,
                    commonNames: commonNames,
                    scientificNames: scientificNames,
                }

                let accordionItems = buildAccordionItem(params);
                $(accordionSighting).append(accordionItems);

                orderElements(accordionSighting);
                buildProvince(params);
                buildMap(params);
                buildDelete(params);
                buildSelect(params);
            });

            const accordionLanding = "#accordion-landing";
            const addLanding = "#add-landing";

            let landingUID = 0;
            $(addLanding).on('click', function() {
                let params = {
                    uid: `L${++landingUID}`,
                    type: LANDING_DATA,
                    commonNames: commonNames,
                    scientificNames: scientificNames,
                }

                let accordionItems = buildAccordionItem(params);
                $(accordionLanding).append(accordionItems);

                orderElements(accordionLanding);
                buildProvince(params);
                buildMap(params);
                buildDelete(params);
                buildSelect(params);
            });

            function orderElements(element) {
                let order = 1;
                let prefix = element === accordionSighting ? "Sighting S" : "Landing L";
                let el = $(element).children();

                for (let e of el) {
                    let accordionItem = $(e).first().children();
                    let accordionHeader = $(accordionItem).first().children();
                    let accordionBtn =  $(accordionHeader).first();
                    $(accordionBtn).text(`${prefix}${order}`);
                    order++;
                }
            }

            function buildAccordionItem(params) {
                return `
                    <div class="accordion-item" id="item-${params.uid}">
                        ${buildHeader(params)}
                        ${buildBody(params)}
                    </div>
                `;
            }

            function buildHeader(params) {
                return `
                    <div class="accordion-header" id="heading-${params.uid}">
                        <button id="heading-btn-${params.uid}" class="accordion-button" type="button" data-bs-toggle="collapse"
                                data-bs-target="#collapse-${params.uid}" aria-expanded="true"
                                aria-controls="collapse-${params.uid}">
                            ${params.type} ${params.uid}
                        </button>
                    </div>
                `;
            }

            function buildBody(params) {
                return `
                    <div id="collapse-${params.uid}" class="accordion-collapse collapse show" aria-labelledby="heading-${params.uid}">
                        <div class="accordion-body">
                            <div class="row mb-4 g-3">
                                <div class="h5 c-blue">Informasi Elasmobranch</div>
                                ${requiredForm(params)}
                            </div>
                            <div class="row g-3">
                                <div class="h5 c-blue">Informasi Tambahan</div>
                                ${additionalForm(params)}
                            </div>
                            <div class="row g-3">
                                ${deleteForm(params)}
                            </div>
                        </div>
                    </div>
                `;
            }

            function buildSelect(params) {
                let commonNameSelect = $(`#common_name-${params.uid}`);
                $.each(params.commonNames, function(index, item) {
                  commonNameSelect.append(new Option(item, item));
                })

                let scientificNameSelect = $(`#scientific_name-${params.uid}`);
                $.each(params.scientificNames, function(index, item) {
                  scientificNameSelect.append(new Option(item, item));
                })

                function newTag(params, data){
                    let term = $.trim(params.term);
                    if (term === '') {
                      return null;
                    }
                      return {
                          id: term,
                          text: "(NEW) " + term,
                          newTag: true
                      }
                }

                commonNameSelect.select2({
                    tags: true,
                    allowClear: true,
                    placeholder: 'Common Name',
                    createTag: newTag,
                });

                scientificNameSelect.select2({
                    tags: true,
                    allowClear: true,
                    placeholder: 'Scientific Name',
                    createTag: newTag,
                });
            }

            function buildDelete(params) {
              $(`#delete-${params.uid}`).on('click', function () {
                    $(`#item-${params.uid}`).remove();

                    if (params.uid.includes("S")) {
                        orderElements(accordionSighting);
                    } else {
                        orderElements(accordionLanding);
                    }
                });
            }

            function buildProvince(params) {
                let province = $(`#province-${params.uid}`);
                $.each(provinces, function(index, item) {
                  province.append(new Option(item.name, item.name));
                });
            }

            function buildMap(params) {
                let mapMarker;
                let latitude = $(`#latitude-${params.uid}`);
                let longitude = $(`#longitude-${params.uid}`);

                const jakarta = [-6.2, 106.816];
                const zoomLevel = 7;

                let map = L.map(`map-${params.uid}`, {
                    center: jakarta,
                    zoom: zoomLevel
                });

                let oceanBaseMap = L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
                    maxZoom: 18,
                    attribution: '&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors, Points &copy 2012 LINZ'
                });

                oceanBaseMap.addTo(map);

                function onMapClick(e) {
                    if (!mapMarker) {
                        mapMarker = new L.Marker(e.latlng, {draggable: 'true'});
                        latitude.val(e.latlng.lat)
                        longitude.val(e.latlng.lng);

                        mapMarker.on('dragend', function (event) {
                            let marker = event.target;
                            let position = marker.getLatLng();
                            mapMarker.setLatLng(new L.LatLng(position.lat, position.lng), {draggable: 'true'});
                            map.panTo(new L.LatLng(position.lat, position.lng));
                            latitude.val(position.lat);
                            longitude.val(position.lng);
                        });
                        map.addLayer(mapMarker);
                    }
                }

                latitude.change(function () {
                    let position = mapMarker.getLatLng();
                    mapMarker.setLatLng(new L.LatLng($(this).val(), position.lng), {draggable: 'true'});
                    map.panTo(new L.LatLng($(this).val(), position.lng))
                })

                longitude.change(function () {
                    let position = mapMarker.getLatLng();
                    mapMarker.setLatLng(new L.LatLng(position.lat, $(this).val()), {draggable: 'true'});
                    map.panTo(new L.LatLng(position.lat, $(this).val()))
                })

                map.on('click', onMapClick);
            }

            let deleteForm = (params) => {
                return `
                    <div class="col-md-12">
                        <div class="text-end mt-3">
                            <div class="btn btn-danger remove-item" id="delete-${params.uid}">
                                <i class="bi bi-trash"></i>
                            </div>
                        </div>
                    </div>
                `;
            }

            let requiredForm = (params) => {
                let optDepthForm = `
                    <label for="depth" class="form-label mt-2">
                        Kedalaman <span class="c-red">*</span>
                    </label>
                    <div class="input-group">
                        <input type="text" class="form-control" name="depth-${params.uid}" id="depth-${params.uid}" required>
                        <span class="input-group-text">meter</span>
                    </div>
                `;

                return `
                    <div class="col-md-12">
                        <label for="datetime" class="form-label">Tanggal dan Waktu Perjumpaan <span class="c-red">*</span></label>
                        <input type="datetime-local" class="form-control" name="datetime-${params.uid}" id="datetime-${params.uid}" required>
                    </div>
                    <div class="col-md-6">
                        <label for="location" class="form-label">
                            Lokasi Perjumpaan <span class="c-red">*</span>
                        </label>
                        <input type="text" class="form-control" name="location-${params.uid}" id="location-${params.uid}" required>
                    </div>
                    <div class="col-md-6">
                        <label for="province" class="form-label">
                            Provinsi <span class="c-red">*</span>
                        </label>
                        <select class="form-select" name="province-${params.uid}" id="province-${params.uid}" required>

                        </select>
                    </div>
                    <div class="col-md-6">
                        <label for="latitude" class="form-label">
                            Latitude <span class="c-red">*</span>
                        </label>
                        <input type="text" class="form-control" name="latitude-${params.uid}" id="latitude-${params.uid}" required>
                        <label for="longitude" class="form-label mt-2">
                            Longitude <span class="c-red">*</span>
                        </label>
                        <input type="text" class="form-control" name="longitude-${params.uid}" id="longitude-${params.uid}" required>
                        <hr/>
                        ${params.type === SIGHTING_DATA ? optDepthForm : ""}
                    </div>
                    <div class="col-md-6">
                        <div class="map" id="map-${params.uid}"></div>
                    </div>
                    <div class="col-md-12">
                        <label for="formFileMultiple" class="form-label">
                            Unggah Foto <span class="c-red">*</span>
                        </label>
                        <input class="form-control" type="file" accept=".png, .jpg, .jpeg" onchange="checkFileSize(this)" name="upload-${params.uid}" id="formFileMultiple" multiple required>
                        <small id="imageHelp" class="form-text text-muted">Ukuran maksimal: 2.5 MB, ekstensi yang diizinkan: .png, .jpg, .jpeg</small>
                    </div>
                `;
            }

            let additionalForm = (params) => {
                let optCaptureMethodForm =  `
                    <div class="col-md-12">
                        <label for="capture_method" class="form-label">
                            Metode Penangkapan
                        </label>
                        <input type="text" class="form-control" name="capture_method-${params.uid}" id="capture_method-${params.uid}">
                    </div>
                `;

                let optHabitatForm = `
                    <div class="col-md-6">
                        <label for="habitat" class="form-label">
                            Habitat saat Perjumpaan
                        </label>
                        <div class="form-check">
                            <input class="form-check-input" type="checkbox" name="habitat-${params.uid}" value="sand">
                            <label class="form-check-label" for="habitat">Pasir</label>
                        </div>
                        <div class="form-check">
                            <input class="form-check-input" type="checkbox" name="habitat-${params.uid}" value="mud">
                            <label class="form-check-label" for="habitat">Lumpur</label>
                        </div>
                        <div class="form-check">
                            <input class="form-check-input" type="checkbox" name="habitat-${params.uid}" value="coralReef">
                            <label class="form-check-label" for="habitat">Terumbu Karang</label>
                        </div>
                        <div class="form-check">
                            <input class="form-check-input" type="checkbox" name="habitat-${params.uid}" value="openWater">
                            <label class="form-check-label" for="habitat">Perairan Terbuka</label>
                        </div>
                        <div class="form-check">
                            <input class="form-check-input" type="checkbox" name="habitat-${params.uid}" value="seagrassBed">
                            <label class="form-check-label" for="habitat">Padang Lamun</label>
                        </div>
                        <div class="form-check">
                            <input class="form-check-input" type="checkbox" name="habitat-${params.uid}" value="mangrove">
                            <label class="form-check-label" for="habitat">Mangrove / Bakau</label>
                        </div>
                    </div>
                `;

                return `
                    <div class="col-md-12">
                        <label for="common_name" class="form-label">
                            Common Name
                        </label>
                        <select class="form-select" name="common_name-${params.uid}" id="common_name-${params.uid}">
                            <option></option>
                        </select>
                    </div>
                    <div class="col-md-12">
                        <label for="scientific_name" class="form-label">
                            Scientific Name
                        </label>
                        <select class="form-select" name="scientific_name-${params.uid}" id="scientific_name-${params.uid}">
                            <option></option>
                        </select>
                    </div>
                    ${params.type === LANDING_DATA ? optCaptureMethodForm : ""}
                    <div class="col-md-6">
                        <label for="weight" class="form-label">
                            Berat
                        </label>
                        <div class="input-group">
                            <input type="text" class="form-control" name="weight-${params.uid}" id="weight-${params.uid}">
                            <span class="input-group-text">kg</span>
                        </div>
                    </div>
                    <div class="col-md-6">
                        <label for="length" class="form-label">
                            Panjang
                        </label>
                        <div class="input-group">
                            <input type="text" class="form-control" name="length-${params.uid}" id="length-${params.uid}">
                            <span class="input-group-text">meter</span>
                        </div>
                    </div>
                    <div class="col-md-${params.type === SIGHTING_DATA ? 6 : 12}">
                        <label for="sex" class="form-label">
                            Jenis Kelamin
                        </label>
                        <div class="form-check">
                            <input class="form-check-input" type="radio" name="sex-${params.uid}"
                                   value="male">
                            <label class="form-check-label" for="sex">Jantan</label>
                        </div>
                        <div class="form-check">
                            <input class="form-check-input" type="radio" name="sex-${params.uid}"
                                   value="female">
                            <label class="form-check-label" for="sex">Betina</label>
                        </div>
                        <div class="form-check">
                            <input class="form-check-input" type="radio" name="sex-${params.uid}"
                                   value="unidentified">
                            <label class="form-check-label" for="sex">Belum teridentifikasi</label>
                        </div>
                    </div>
                    ${params.type === SIGHTING_DATA ? optHabitatForm : ""}
                    <div class="col-md-12">
                        <label for="description" class="form-label">
                            Deskripsi Pertemuan
                        </label>
                        <textarea name="description-${params.uid}" class="form-control" rows="3"></textarea>
                    </div>
                    <div class="col-md-12">
                        <label for="action" class="form-label">
                            Apa yang sedang kamu lakukan saat bertemu dengan Elasmobranchii tersebut?
                        </label>
                        <textarea name="action-${params.uid}" class="form-control" rows="3"></textarea>
                    </div>
                    <div class="col-md-12">
                        <label for="activity" class="form-label">
                            Seberapa sering kamu di daerah di mana kamu melihat Elasmobranchii tersebut?
                        </label>
                        <textarea name="activity-${params.uid}" class="form-control" rows="3"></textarea>
                    </div>
                `;
            };
        })

        function checkFileSize(input) {
            var maxSize = 2.5 * 1024 * 1024;
            if (input.files.length > 0) {
                var fileSize = input.files[0].size;
                if (fileSize > maxSize) {
                    alert('File size is too large.')
                    input.value = '';
                }
            }
        }
    </script>
{% endblock js %}